define(["exports", "core/ui"], function (exports, _ui) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.show = undefined;


  // window.respecVersion is added at build time (see tools/builder.js)
  window.respecVersion = window.respecVersion || "Developer Edition"; // Module ui/about-respec
  // A simple about dialog with pointer to the help

  var div = document.createElement("div");
  div.innerHTML = "\n  <p>\n    ReSpec is a document production toolchain, with a notable focus on W3C specifications.\n  </p>\n  <p>\n    You can find more information in the <a href='https://w3.org/respec/'>documentation</a>.\n  </p>\n  <p>\n    Found a bug in ReSpec? <a href='https://github.com/w3c/respec/issues'>File it!</a>.\n  </p>\n";

  var button = _ui.ui.addCommand("About ReSpec", "ui/about-respec", "Ctrl+Shift+Alt+A", "ℹ️");

  function show() {
    _ui.ui.freshModal("About ReSpec - " + window.respecVersion, div, button);
  }

  exports.show = show;
});
//# sourceMappingURL=about-respec.js.map